{$mode objfpc}{$assertions on}{$r+}{$h+}
uses Math;

procedure Aperiodic; begin Write(0); Halt; end;

var
  r: array of array of record a, p: Integer; end;
  i, d, sp, sa: Integer;
  s: String;
begin
  AssignFile(input, 'input.txt'); Reset(input);
  AssignFile(output, 'output.txt'); Rewrite(output);
  Read(s);
  Assert(Length(s) <= 25);
  SetLength(r, 2, 1);
  r[0][0].a := 1; r[1][0].a := 1;
  d := 0; i := 1; sp := -1;
  while i <= Length(s) do begin
    case s[i] of
      '+': begin
        Assert((i > 1) and not (s[i - 1] in ['+', '*']));
        SetLength(r[d], Length(r[d]) + 1);
        r[d][High(r[d])].a := 1;
      end;
      '*':  begin
        Assert((i > 1) and not (s[i - 1] in ['+', '*', '(']));;
      end;
      'x': begin
        Assert((i = 1) or (s[i - 1] in ['+', '*', '(']));
        r[d][High(r[d])].p += 1;
      end;
      '0'..'9': begin
        Assert((i = 1) or (s[i - 1] in ['+', '*', '(']));
        r[d][High(r[d])].a *= Ord(s[i]) - Ord('0');
      end;
      's': begin
        Assert((i = 1) or (s[i - 1] in ['+', '*']));
        Assert((sp < 0) and (d = 0));
        sp := High(r[0]);
        d := 1;
        Assert(Copy(s, i, 4) = 'sin(');
        i += 3;
      end;
      ')': begin
        Assert((sp >= 0) and (d = 1));
        d := 0;
      end;
    end;
    i += 1;
  end;
  Assert(not (s[Length(s)] in ['+', '*']));
  Assert(d = 0);

  if sp < 0 then Aperiodic;

  for i := 0 to High(r[0]) do
    if (i <> sp) and (r[0][i].p <> 0) and (r[0][i].a <> 0) then Aperiodic;

  //Writeln(r[0][sp].a, '*sin()*x^', r[0][sp].p);
  if (r[0][sp].a = 0) or (r[0][sp].p <> 0) then Aperiodic;

  sa := 0;
  for i := 0 to High(r[1]) do
    case r[1][i].p of
    0: ;
    1: sa += r[1][i].a;
    else if r[1][i].a <> 0 then Aperiodic;
  end;
  if sa = 0 then Aperiodic;
  //Writeln('sin(', sa, '*x)');
  Write(2 * Pi / sa);
end.
